| http://www.sim.no/ http://www.coin3d.org/

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
SoGLLineWidthElement Class Reference
Element Classes

The SoGLLineWidthElement class changes the linewidth setting of the OpenGL render state.Requests from the scenegraph to change the linewidth when rendering OpenGL line primitives will be made through this element, which forwards it to the appropriate native OpenGL call. More...

`#include <Inventor/elements/SoGLLineWidthElement.h>`

Inheritance diagram for SoGLLineWidthElement:

## Public Member Functions

virtual void | init (SoState *state)
virtual void | push (SoState *state)
virtual void | pop (SoState *state, const SoElement *prevTopElement)
Public Member Functions inherited from SoFloatElement
virtual SbBool | matches (const SoElement *element) const
virtual SoElement * | copyMatchInfo (void) const
virtual void | print (FILE *file) const
Public Member Functions inherited from SoElement
const SoType | getTypeId (void) const
int | getStackIndex (void) const
void | setDepth (const int depth)
int | getDepth (void) const
virtual | ~SoElement ()

## Static Public Member Functions

static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
Static Public Member Functions inherited from SoLineWidthElement
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | set (SoState *const state, SoNode *const node, const float lineWidth)
static void | set (SoState *const state, const float lineWidth)
static float | get (SoState *const state)
static float | getDefault ()
Static Public Member Functions inherited from SoFloatElement
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initClass (void)
static void | set (const int stackIndex, SoState *const state, SoNode *const node, const float value)
static void | set (const int stackIndex, SoState *const state, const float value)
static float | get (const int stackIndex, SoState *const state)
Static Public Member Functions inherited from SoElement
static void | initClass (void)
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initElements (void)
static int | getNumStackIndices (void)
static SoType | getIdFromStackIndex (const int stackIndex)

## Protected Member Functions

virtual | ~SoGLLineWidthElement ()
virtual void | setElt (float width)
Protected Member Functions inherited from SoLineWidthElement
virtual | ~SoLineWidthElement ()
Protected Member Functions inherited from SoFloatElement
virtual | ~SoFloatElement ()
Protected Member Functions inherited from SoElement
| SoElement (void)
void | capture (SoState *const state) const
virtual void | captureThis (SoState *state) const
void | setTypeId (const SoType typeId)
void | setStackIndex (const int index)
SoElement * | getNextInStack (void) const
SoElement * | getNextFree (void) const

## Additional Inherited Members

Static Protected Member Functions inherited from SoElement
static SoElement * | getElement (SoState *const state, const int stackIndex)
static const SoElement * | getConstElement (SoState *const state, const int stackIndex)
static int | createStackIndex (const SoType id)
Protected Attributes inherited from SoFloatElement
float | data
Protected Attributes inherited from SoElement
SoType | typeId
int | stackIndex
int | depth
Static Protected Attributes inherited from SoElement
static int | classStackIndex
static SoTypeList * | stackToType

## Detailed Description

The SoGLLineWidthElement class changes the linewidth setting of the OpenGL render state.

Requests from the scenegraph to change the linewidth when rendering OpenGL line primitives will be made through this element, which forwards it to the appropriate native OpenGL call.

The Coin library does not place any bounds on the values of the linewidths, but be aware that the range and granularity of what is valid linewidths depends on the underlying OpenGL implementation. Application programmers using line primitives (typically through the SoLineSet or SoIndexedLineSet nodes) should heed these boundary values. They can be acquired by running the following code from within a valid OpenGL context:

GLfloat bounds[2];
glGetFloatv(GL_LINE_WIDTH_RANGE, bounds);
GLfloat granularity[1];
glGetFloatv(GL_LINE_WIDTH_GRANULARITY, granularity);

Another, perhaps more convenient, way of acquiring the OpenGL implementation limits with regard to pointsizes is to use the So*GLWidget::getPointSizeLimits() method in the GUI "glue" interface library you are using (SoQt, SoXt, SoGtk, SoWin, ...).

## Constructor & Destructor Documentation

## ◆ ~SoGLLineWidthElement()

SoGLLineWidthElement::~SoGLLineWidthElement | ( | void |  | ) |

protectedvirtual

Destructor.

## Member Function Documentation

## ◆ createInstance()

void * SoGLLineWidthElement::createInstance | ( | void |  | ) |

static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ init()

void SoGLLineWidthElement::init | ( | SoState * | state | ) |

virtual

This function initializes the element type in the given SoState. It is called for the first element of each enabled element type in SoState objects.

Reimplemented from SoLineWidthElement.

## ◆ push()

void SoGLLineWidthElement::push | ( | SoState * | state | ) |

virtual

This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoElement.

## ◆ pop()

void SoGLLineWidthElement::pop | ( | SoState * | state,
|  | const SoElement * | prevTopElement
| ) |  |

virtual

This method is callled when the state is popped, and the depth of the element is bigger than the current state depth. pop() is called on the new top of stack, and a pointer to the previous top of stack is passed in prevTopElement.

Override this method if you need to copy some state information from the previous top of stack.

Reimplemented from SoElement.

## ◆ setElt()

void SoGLLineWidthElement::setElt | ( | float | value | ) |

protectedvirtual

Set element value.

Reimplemented from SoFloatElement.

The documentation for this class was generated from the following files:

- SoGLLineWidthElement.h
- SoGLLineWidthElement.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.